package vm

import (
	"context"
	"github.com/jinzhu/copier"
	"github.com/pkg/errors"
	"gitlink.org.cn/JointCloud/pcm-coordinator/pkg/helper/xerr"
	"gitlink.org.cn/JointCloud/pcm-coordinator/pkg/repository/result"
	"gitlink.org.cn/JointCloud/pcm-coordinator/pkg/utils"
	"gitlink.org.cn/JointCloud/pcm-openstack/openstack"
	"k8s.io/apimachinery/pkg/util/json"

	"gitlink.org.cn/JointCloud/pcm-coordinator/internal/svc"
	"gitlink.org.cn/JointCloud/pcm-coordinator/internal/types"

	"github.com/zeromicro/go-zero/core/logx"
)

type DeleteFirewallGroupLogic struct {
	logx.Logger
	ctx    context.Context
	svcCtx *svc.ServiceContext
}

func NewDeleteFirewallGroupLogic(ctx context.Context, svcCtx *svc.ServiceContext) *DeleteFirewallGroupLogic {
	return &DeleteFirewallGroupLogic{
		Logger: logx.WithContext(ctx),
		ctx:    ctx,
		svcCtx: svcCtx,
	}
}

func (l *DeleteFirewallGroupLogic) DeleteFirewallGroup(req *types.DeleteFirewallGroupReq) (resp *types.DeleteFirewallGroupResp, err error) {
	// todo: add your logic here and delete this line
	DeleteFirewallGroupReq := &openstack.DeleteFirewallGroupReq{}
	err = copier.CopyWithOption(DeleteFirewallGroupReq, req, copier.Option{Converters: utils.Converters})
	DeleteFirewallGroupResp, err := l.svcCtx.OpenstackRpc.DeleteFirewallGroup(l.ctx, DeleteFirewallGroupReq)
	if err != nil {
		return nil, errors.Wrapf(xerr.NewErrMsg("c端创建失败"), "c端创建失败 : %v ,req:%+v", err, req)
	}
	marshal, err := json.Marshal(&DeleteFirewallGroupResp)
	if err != nil {
		return nil, result.NewDefaultError(err.Error())
	}
	json.Unmarshal(marshal, &resp)
	err = copier.CopyWithOption(&resp, &DeleteFirewallGroupResp, copier.Option{Converters: utils.Converters})
	return resp, err
}
